/*
 * Copyright 2013 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.awk.builtin.mat;

import net.morilib.awk.builtin.AwkBinaryArgs;
import net.morilib.awk.io.AwkFiles;
import net.morilib.awk.matrix.DoubleMatrix;
import net.morilib.awk.matrix.DoubleVector;
import net.morilib.awk.namespace.AwkNamespace;
import net.morilib.awk.value.AwkUndefined;
import net.morilib.awk.value.AwkValue;

/**
 * 関数mat.multiplyの記述です。
 *
 *
 * @author MORIGUCHI, Yuichiro 2013/03/31
 */
public class MatMultiply extends AwkBinaryArgs {

	/**
	 * @param name
	 */
	protected MatMultiply() {
		super("multiply");
	}

	/* (non-Javadoc)
	 * @see net.morilib.awk.builtin.AwkBinaryArgs#apply(net.morilib.awk.namespace.AwkNamespace, net.morilib.awk.io.AwkFiles, net.morilib.awk.value.AwkValue, net.morilib.awk.value.AwkValue)
	 */
	@Override
	public AwkValue apply(AwkNamespace ns, AwkFiles o, AwkValue a1,
			AwkValue a2) {
		DoubleMatrix a, b, c;
		DoubleVector v, w;
		String sep;

		sep = ns.getRoot().find(AwkMatrices.SUBSEP).toString(ns);
		if(!a1.isArray()) {
			return AwkUndefined.UNDEF;
		} else if((a = AwkMatrices.toDoubleMatrix(a1, sep)) == null) {
			return AwkUndefined.UNDEF;
		} else if((b = AwkMatrices.toDoubleMatrix(a2, sep)) != null) {
			c = b.mul(a);
			return AwkMatrices.toAwkArray(c, sep);
		} else {
			v = AwkMatrices.toDoubleVector(a2);
			w = a.mul(v);
			return AwkMatrices.toAwkArray(w);
		}
	}

}
